;;;; crunch - syntax for accessing C in crunched code

(module (crunch c)

  (c-include c-lambda c-external c-declare)

  (import (scheme base))

  (define-syntax c-include
    (er-macro-transformer
      (lambda (x r c)
         `(##core#c-declare
             ,(map (lambda (inc)
             	     (string-append
                       "#include "
                       (if (symbol? inc)
                           (symbol->string (strip-syntax inc))
                           (string-append "\"" inc "\"\n"))))
                   (cdr x))))))

  (define-syntax c-lambda
    (syntax-rules ()
      ((_ rtype (args ...) body ...)
        (##core#c-lambda rtype (args ...) (body ...)))))

  (define-syntax c-declare
    (syntax-rules ()
      ((_ text ...) (##core#c-declare (text ...)))))

  (define-syntax c-external
    (syntax-rules ()
      ((_ include name (args ...) type)
        (##core#c-external include name (args ...) type))
      ((_ name (args ...) type)
        (##core#c-external #f name (args ...) type))))

)
